from keras.applications.vgg16 import VGG16
from keras.layers import Input, Flatten, Dense, Dropout, Activation
from keras.models import Sequential, Model
from keras.layers.convolutional import Conv2D, MaxPooling2D
from keras.optimizers import RMSprop, Adam,SGD
from keras.layers import LeakyReLU

lrelu = lambda x: tf.keras.activations.relu(x, alpha=0.1)


model_vgg = VGG16(include_top=False, weights="imagenet", input_shape=(HEIGHT,WIDTH,CHANNELS))
for layer in model_vgg.layers:
    layer.trainable = False
model = Flatten(name = 'flatten')(model_vgg.output)
model = Dense(512, activation = lrelu)(model)
model = Dropout(0.5)(model)
model = Dense(512, activation = lrelu)(model)
model = Dropout(0.5)(model)
model = Dense(31, activation = "softmax")(model)

model_vgg_ardis = Model(model_vgg.input, model, name='vgg16')
model_vgg_ardis.summary()
model_vgg_ardis.compile(loss='categorical_crossentropy',optimizer = Adam(0.0001), metrics = ['accuracy'])